/*->c.pngim */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"
#include "process.h"


#include "err.h"
#include "fsx.h"
#include "task.h"
#include "alloc.h"
#include "trans.h"
#include "etc.h"
#include "bf.h"
#include "xmath.h"



#include "str.h"



#include "main.h"
#include "im.h"


#include "png.h"


#include "pngim.h"





static int tdbl;
static int dbl;
static int tinterlace;
static int interlace;

static int pngxres=90;
static int pngyres=90;
static int txres;
static int tyres;






/*****************************************************************************/







static png_color_16 my_background=
{
 0,
 0x0,
 0x0,
 0x0,
 0,
};





static void user_read_data(png_structp png_ptr, png_bytep data,
                                                        png_size_t length)
{
 buffer * bf=(buffer*)png_get_io_ptr(png_ptr);

 bf_read(bf,data,(int)length);
}



static void user_write_data(png_structp png_ptr, png_bytep data,
                                                         png_size_t length)
{
 buffer * bf=(buffer*)png_get_io_ptr(png_ptr);

 bf_write(bf,data,(int)length);
}



static void user_flush_data(png_structp png_ptr)
{
 USE(png_ptr);
}



static void user_error(png_structp png_ptr, png_const_charp error_msg)
{
 os_error * err;

// dprintf(0,"user_error %d",error_msg);

 err=generror(0x600,"PNG:%s",error_msg);
 longjmp(png_ptr->jmpbuf,(int)err);  /* return control to outer routine */
}




static void user_warning(png_structp png_ptr,png_const_charp warning_msg)
{
 USE(png_ptr);
 USE(warning_msg);
}


#define BIGBUFFSIZE 0x20000



os_error * loadpng(char * name,int type,int userhandle,int xvolatile)
{
 os_error  * err;
 png_bytep   row_buf;
 png_byte  * near_row_buf;
 png_uint_32 rowbytes;
 png_uint_32 y;
 int         channels;
 int         num_pass;
 int         pass;
 png_struct  read_ptr;
 png_info    info_ptr;
 png_info    end_info;
 int       * idata;
 imagestr  * loadimage;
 int         fn;
 int         i;
 int         bpp;
 buffer      bf;

// dprintf(0,"loadpng");

 err=NULL;


 row_buf=(png_bytep)0;
 near_row_buf=(png_byte *)0;


 err=bf_open(name,'r',BIGBUFFSIZE,&bf);
 if(!err)
 {
  png_set_error_fn(&read_ptr,NULL,user_error,user_warning);

  if((err=(os_error*)setjmp(read_ptr.jmpbuf))!=NULL)
  {
   png_read_destroy(&read_ptr,&info_ptr,&end_info);
   sfree((flex_ptr)&near_row_buf);
  }
  else
  {
   png_read_init(&read_ptr);
   png_info_init(&info_ptr);
   png_info_init(&end_info);


   png_set_read_fn(&read_ptr,(voidp)&bf,user_read_data);

   png_read_info(&read_ptr,&info_ptr);

   /* fill background */

   if(info_ptr.valid & PNG_INFO_bKGD)
        png_set_background(&read_ptr, &(info_ptr.background),
              PNG_BACKGROUND_GAMMA_FILE, 1, 1.0);
   else  
        png_set_background(&read_ptr, &my_background,
           PNG_BACKGROUND_GAMMA_SCREEN, 0, 1.0);


   /* get rid of 16 bit data */

   if(info_ptr.bit_depth==16) png_set_strip_16(&read_ptr);


   if(info_ptr.interlace_type)
   {
    num_pass=png_set_interlace_handling(&read_ptr);
   }
   else
   {
    num_pass=1;
   }

   png_read_update_info(&read_ptr,&info_ptr);

   if((info_ptr.color_type & PNG_COLOR_TYPE_PALETTE)==PNG_COLOR_TYPE_RGB)
                                                       channels=3;
   else                                                channels=1;

   if(info_ptr.color_type & PNG_COLOR_MASK_ALPHA)      channels++;


   rowbytes=((info_ptr.width*info_ptr.bit_depth*channels+7)>>3);

   err=salloc((flex_ptr)&near_row_buf,(int)rowbytes);
   if(!err)
   {
    row_buf=(png_bytep)near_row_buf;

    addframe(loadfile,&fn,0);
    loadfile->frames[fn].fxpix=(int)info_ptr.width;
    loadfile->frames[fn].fypix=(int)info_ptr.height;
    sprintf(loadfile->frames[fn].name,"PNG%d",fn);
    loadfile->frames[fn].fbpp=bpp=info_ptr.bit_depth*channels;

    if((info_ptr.valid & PNG_INFO_pHYs) &&
        info_ptr.phys_unit_type==PNG_RESOLUTION_METER)
    {
     loadfile->frames[fn].fxdpi=
                             scale((int)info_ptr.x_pixels_per_unit,254,10000);
     loadfile->frames[fn].fydpi=
                             scale((int)info_ptr.y_pixels_per_unit,254,10000);
    }
    else
    {
     loadfile->frames[fn].fxdpi=pngxres;
     loadfile->frames[fn].fydpi=pngyres;
    }

    loadfile->frames[fn].xim=NULL;

    err=ximnew(loadfile->frames[fn].fxpix,loadfile->frames[fn].fypix,
                                            bpp,&loadfile->frames[fn].xim);

    if(!err)
    {
     loadimage=((loadfile->frames[fn].xim)->sim[IM]);
     loadimage->xdpi=loadfile->frames[fn].fxdpi;
     loadimage->ydpi=loadfile->frames[fn].fydpi;


     if(info_ptr.color_type & PNG_COLOR_MASK_PALETTE)
     {
      loadimage->ipal.ncolours=info_ptr.num_palette;
      for(i=0;i<info_ptr.num_palette;i++)
      {
       loadimage->ipal.word[i]=(info_ptr.palette[i].red<<8) |
                               (info_ptr.palette[i].green<<16) |
                               (info_ptr.palette[i].blue<<24);
      }
     }
     else
     if((info_ptr.color_type & PNG_COLOR_TYPE_PALETTE)==PNG_COLOR_TYPE_GRAY)
     {
      imsetgreypal(loadimage,bpp);
     }

/*     dprintf(0,"trans=%d",info_ptr.num_trans); */


     for(pass=0;pass<num_pass;pass++)
     {
      for(y=0;y<info_ptr.height;y++)
      {
       if(pass>0)
       {
        err=imfind1w(loadimage,(int)y,&idata);
        if(err) break;
        XMEMCPYX(row_buf,idata,(int)rowbytes);
       }

       png_read_rows(&read_ptr,(png_bytepp)&row_buf,(png_bytepp)0,1);

       err=imfind1w(loadimage,(int)y,&idata);
       if(err) break;
       XMEMCPYX(idata,row_buf,(int)rowbytes);
      }
     }


     if(bpp!=24)
     {
      for(y=0;y<info_ptr.height;y++)
      {
       imrevline(loadimage,(int)y);
      }
     }

     png_read_end(&read_ptr, &end_info);

//     getinfo(&loadfile->frames[fn]);
    }

    sfree((flex_ptr)&near_row_buf);
   }

   png_read_destroy(&read_ptr,&info_ptr,&end_info);
  }
  err=bf_close(&bf,err);
 }


 return(err);

 USE(type);
 USE(userhandle);
 USE(xvolatile);
}




/*****************************************************************************/



os_error * savepng(filestr * file,int fn,char * name,int type)
{
 os_error  * err;
 png_struct  png_ptr;
 png_info    info_ptr;
 imagestr  * saveimage;
 int         x;
 int         y;
 int         pass;
 int         height;
 int       * idata;
 int         i;
 int         number_passes;
 int         bpp;
 int         xpix;
 char      * p;
 char      * q;
 char      * temp;
 int         wwidth;
 int         ch;
 buffer      bf;


 err=NULL;


 memset(&info_ptr,0,sizeof(png_info));
 temp=NULL;

 saveimage=((file->frames[fn].xim)->sim[IM]);
 bpp=saveimage->bpp;
 xpix=saveimage->xpix;
 wwidth=((bpp*xpix+31) & ~0x1F)>>3;


 err=bf_open(name,'w',BIGBUFFSIZE,&bf);
 if(!err)
 {
  /* set error handling */

  png_set_error_fn(&png_ptr,NULL,user_error,user_warning);

  if((err=(os_error*)setjmp(png_ptr.jmpbuf))!=NULL)
  {
   sfree((flex_ptr)&temp);
   png_write_destroy(&png_ptr);
   if(info_ptr.palette) sfree((flex_ptr)&info_ptr.palette);
  }
  else
  {
   /* initialize the structures */

   png_info_init(&info_ptr);
   png_write_init(&png_ptr);

   png_set_write_fn(&png_ptr,(voidp)&bf,user_write_data,user_flush_data);


   /* set the file information here */

   info_ptr.width=saveimage->xpix;
   info_ptr.height=height=saveimage->ypix;
   info_ptr.bit_depth=saveimage->bpp;
   if(info_ptr.bit_depth>8) info_ptr.bit_depth=8;
   info_ptr.color_type=
                    saveimage->bpp>8?PNG_COLOR_TYPE_RGB:PNG_COLOR_TYPE_PALETTE;
   info_ptr.interlace_type=interlace;


   /* set the palette if there is one */

   if(saveimage->bpp<=8)
   {
    info_ptr.valid|=PNG_INFO_PLTE;
    err=salloc((flex_ptr)&info_ptr.palette,256*sizeof(png_color));
    if(!err)
    {
     info_ptr.num_palette=saveimage->ipal.ncolours;
 
     for(i=0;i<saveimage->ipal.ncolours;i++)
     {
      info_ptr.palette[i].red=(saveimage->ipal.word[i]>>8) & 0xFF;
      info_ptr.palette[i].green=(saveimage->ipal.word[i]>>16) & 0xFF;
      info_ptr.palette[i].blue=(saveimage->ipal.word[i]>>24) & 0xFF;
     }
    }
   }


   info_ptr.valid|=PNG_INFO_pHYs;
   info_ptr.x_pixels_per_unit=scale(saveimage->xdpi,10000,254);
   info_ptr.y_pixels_per_unit=scale(saveimage->ydpi,10000,254);
   info_ptr.phys_unit_type=PNG_RESOLUTION_METER;


   /* write the file information */
   png_write_info(&png_ptr, &info_ptr);

   /* turn on interlace handling if you are not using png_write_image() */
   if(interlace) number_passes=png_set_interlace_handling(&png_ptr);
   else          number_passes=1;


   if(!err) err=salloc((flex_ptr)&temp,wwidth);
   if(!err)
   {
    for(pass=0;pass<number_passes;pass++)
    {
     for(y=0;y<height;y++)
     {
      err=imfind1r(saveimage,y,&idata);
      if(err) break;

      if(bpp==32)
      {
       q=temp;

       for(x=0;x<xpix;x++)
       {
        ch=*idata++;
        *q++=ch;
        *q++=ch>>8;
        *q++=ch>>16;
       }
      }
      else
      if(bpp==16)
      {
       q=temp;
       for(x=0;x<xpix;x++)
       {
        ch=*idata++;

        *q++=(ch<<3)&0xF8;
        *q++=(ch>>2)&0xF8;
        *q++=(ch>>7)&0xF8;

        x++;
        if(x>=xpix) break;

        *q++=(ch>>13)&0xF8;
        *q++=(ch>>18)&0xF8;
        *q++=(ch>>23)&0xF8;
       }
      }
      else
      if(bpp==24 || bpp==8)
      {
       XMEMCPYX(temp,idata,wwidth);
      }
      else
      if(bpp==1)
      {
       q=temp;
       p=(char*)idata;
       for(i=0;i<wwidth;i++) *q++=bitrev[*p++];
      }
      else
      if(bpp==2)
      {
       q=temp;
       p=(char*)idata;
       for(i=0;i<wwidth;i++) *q++=dbitrev[*p++];
      }
      else
      if(bpp==4)
      {
       q=temp;
       p=(char*)idata;
       for(i=0;i<wwidth;i++) *q++=nybrev[*p++];
      }

      png_write_rows(&png_ptr,(png_byte**)&temp,1);
     }
    }

    sfree((flex_ptr)&temp);
   }

   /* write the rest of the file */

   png_write_end(&png_ptr,&info_ptr);

   /* clean up after the write, and free any memory allocated */
   png_write_destroy(&png_ptr);

   /* if you malloced the palette, free it here */
   if(info_ptr.palette) sfree((flex_ptr)&info_ptr.palette);
  }
  bf_closec(&bf,err,name,type);
 }
 return(err);
}





